﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

namespace FocusBug
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			MyBindingClasses bindingData = new MyBindingClasses();

			bindingData.Add(new MyBindingClass() { ID = 100, Checked = false, Name = "I am 100" });
			bindingData.Add(new MyBindingClass() { ID = 1001, Checked = false, Name = "I am 1001" });
			bindingData.Add(new MyBindingClass() { ID = 1002, Checked = false, Name = "I am 1002" });
			bindingData.Add(new MyBindingClass() { ID = 1003, Checked = false, Name = "I am 1003" });

			ultraCombo1.DataSource = bindingData;
			ultraCombo1.DisplayMember = "Name";
			ultraCombo1.ValueMember = "Id";
			ultraCombo1.CheckedListSettings.CheckStateMember = "Checked";
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			// Will enter here multiple times when bug manifests
			base.OnClosing(e);
		}

		protected override void OnClosed(EventArgs e)
		{
			// Will never enter this method when bug manifests
			base.OnClosed(e);
		}

		//------

		public class MyBindingClass
		{
			public int ID { get; set; }
			public bool Checked { get; set; }
			public string Name { get; set; }
		}

		public class MyBindingClasses : List<MyBindingClass> { }
	}
}
